/*
  CPP_NUM_CORES=32
  CPP_PROCESSES_PER_NODE=1
  CPP_PROBLEM=D
*/

/* RECORD
Universidad Autonoma de Madrid
September 8, 2011
First Spanish Parallel Programming Contest, in situ
time 626 msec
speed-up 26.88
*/

#include <stdlib.h>
#include <stdio.h>
#include <mpi.h>
#include <omp.h>


void mmparcialT(double *a, int fa,int ca,int lda,double *b,int fb,int cb,int ldb,double *c,int fc,int cc,int ldc)
{
        int i, j, k;
        double s;

        #pragma omp parallel for private(i,j,k,s)
        for (i = 0; i < fa; i++)
        {
                for(j=0;j<cb;j++)//cols de b
                {
                        s=0.;
                        for (k = 0; k < ca; k++)//cols de a = filas de b
                                s = s+a[i*lda+k]*b[k+ldb*j];
                        c[i*ldc+j]=s;
                }
        }

}

void mmUnPar(int t,double *a,double *b,double *c,int nodo,int np)
{
        int fl,fini,ftam,i,j;
        MPI_Status estado;

        
        fl=t/np+(t%np>nodo?1:0);
        if(nodo!=0)
        {
                a = (double *) malloc(sizeof(double)*fl*t);
                b = (double *) malloc(sizeof(double)*t*t);
                c = (double *) malloc(sizeof(double)*fl*t);
        }

        if(nodo==0)
        {
                fini=fl;
                for(i=1;i<np;i++)
                {
                        ftam=t/np+(t%np>i?1:0);
                        MPI_Send(&a[t*fini],ftam*t,MPI_DOUBLE,i,20,MPI_COMM_WORLD);
                        fini+=ftam;
                }
                MPI_Bcast(b,t*t,MPI_DOUBLE,0,MPI_COMM_WORLD);//va traspuesta
        }
        else
        {
                MPI_Recv(a,fl*t,MPI_DOUBLE,0,20,MPI_COMM_WORLD,&estado);
                MPI_Bcast(b,t*t,MPI_DOUBLE,0,MPI_COMM_WORLD);//va traspuesta
        }
	mmparcialT(a,fl,t,t,b,t,t,t,c,fl,t,t);


        if(nodo==0)
        {
                fini=t/np+(t%np>0?1:0);
                for(i=1;i<np;i++)
                {
                        ftam=t/np+(t%np>i?1:0);
                        MPI_Recv(&c[t*fini],ftam*t,MPI_DOUBLE,i,30,MPI_COMM_WORLD,&estado);
                        fini+=ftam;
                }
        }
        else
        {
                MPI_Send(c,fl*t,MPI_DOUBLE,0,30,MPI_COMM_WORLD);
        }
        if(nodo!=0)
        {
                free(a);
                free(b);
                free(c);
        }
}


void mm(int t,double *a,double *b,double *c,double *d,double *r,int nodo,int np)
{
	int fl,fini,ftam,i,j;
        MPI_Status estado;
        double *bt,*dt;
	double *res1,*res2,*res2t;

        MPI_Bcast(&t,1,MPI_INT,0,MPI_COMM_WORLD);

	//trasponer matrices
	if(nodo==0)
	{
                bt = (double *) malloc(sizeof(double)*t*t);
                for(i=0;i<t;i++)
                {
                        for(j=0;j<t;j++)
                        {
                                bt[i+t*j]=b[i*t+j];
                        }
                }
		dt = (double *) malloc(sizeof(double)*t*t);
                for(i=0;i<t;i++)
                {
                        for(j=0;j<t;j++)
                        {
                                dt[i+t*j]=d[i*t+j];
                        }
                }
	}

	res1=(double *) malloc(sizeof(double)*t*t);
	res2=(double *) malloc(sizeof(double)*t*t);
	res2t=(double *) malloc(sizeof(double)*t*t);

/*if(nodo==0) escribir(a,t,t);
if(nodo==0) escribir(b,t,t);
if(nodo==0) escribir(c,t,t);
if(nodo==0) escribir(d,t,t);*/

	mmUnPar(t,a,bt,res1,nodo,np);
	//if(nodo==0) escribir(res1,t,t);
	mmUnPar(t,c,dt,res2,nodo,np);
	//if(nodo==0) escribir(res2,t,t);
	if(nodo==0)
	{//trasponer res intermedio
		for(i=0;i<t;i++)
                {
                        for(j=0;j<t;j++)
                        {
                                res2t[i+t*j]=res2[i*t+j];
                        }
                }
	}
	mmUnPar(t,res1,res2t,r,nodo,np);
	//if(nodo==0) escribir(r,t,t);

	free(res1);
	free(res2);
	free(res2t);
}
